
exports.Boot = function () {

};

exports.App = function (appid, url, path) {

    zk.log('[WB]');
    if (!/^assets:\/\/\//i.test(url)
        && !/https?:\/\/[a-z0-9\.]+\.weibo.com\//i.test(url)) {
    }

    var wb = global.wb = {};

    var callbackSet = {};
    var autoId = 0;
    var urlActions = [];

    function addCallback(cb) {
        var id = ++autoId;
        callbackSet[id] = cb;
        return id;
    }

    function addURLAction(pattern, callback) {
        urlActions.push({
            pattern: pattern,
            callback: callback
        })
    }

    function removeURLAction(pattern, callback) {
        if (pattern === undefined && callback === undefined) {
            urlActions = [];
        } else {
            for (var i = 0; i < urlActions.length; i++) {
                var act = urlActions[i];
                if ((pattern === undefined || act.pattern.toString() == pattern.toString())
                    && (callback === undefined || callback == act.callback)) {
                    urlActions.splice(i, 1);
                    i--;
                }
            }
        }
    }

    wb.onaction = function (id) {
        var fn = callbackSet[id];
        if (typeof fn == 'function') {
            var args = [];
            for (var i = 1; i < arguments.length; i++) {
                args.push(arguments[i]);
            }
            fn.apply(undefined, args);
        }
        delete callbackSet[id];
    };

    wb.doURLAction = function (url) {
        var vs = urlActions.slice();
        for (var i = 0; i < vs.length; i++) {
            var v = vs[i];
            if (v.pattern.test(url)) {
                v.callback(url);
            }
        }
    };


    if (zk.platform == 'Android') {


        // var W = new zk.ZKObject('cn/kkmofang/demo/PayProtocol');
        var W = new zk.ZKObject('com/sina/weibo/payment/zk/PayProtocol');

        Object.defineProperties(wb, {
            gsid: {
                get: function () {
                    return W.invoke('gsid');
                }
            },
            uid: {
                get: function () {
                    return W.invoke('uid');
                }
            },
            vp: {
                get: function () {
                    return W.invoke('vp');
                }
            },
            wm: {
                get: function () {
                    return W.invoke('wm');
                }
            },
            from: {
                get: function () {
                    return W.invoke('from');
                }
            },
            ua: {
                get: function () {
                    return W.invoke('ua');
                }
            },
            lang: {
                get: function () {
                    return W.invoke('lang');
                }
            },
            baseURL: {
                get: function () {
                    return W.invoke('baseURL');
                },
                set: function (v) {
                    W.invoke('setBaseURL', v === undefined ? undefined : v + '');
                }
            },
            unreadCount: {
                writable: false,
                value: function (id) {
                    return W.invoke('unreadCount', id + '');
                }
            },
            read: {
                writable: false,
                value: function (id) {
                    return W.invoke('read', id + '');
                }
            },
            act: {
                writable: false,
                value: function (code, data) {
                    W.invoke('act', code, data);
                }
            },

            openURL: {
                writable: false,
                value: function (url) {
                    zk.openURL(url);
                }
            },

            isDeviceApplePayEnabled: {
                get: function () {
                    return false;
                }
            },

            isDeviceAlipayEnabled: {
                get: function() {
                  return W.invoke('isDeviceAlipayEnabled');
                }
            },

            applePay: {
                writable: false,
                value: function (tn, merchantType, mode, callback) {

                }
            },

            isDeviceWxPayEnabled: {
                get: function () {
                    return W.invoke('isDeviceWxPayEnabled');
                }
            },

            wxPay: {
                writable: false,
                value: function (params, callback) {
                    var id = addCallback(callback);
                    W.invoke('wxPay', id, params);
                }
            },

            aliPay: {
                writable: false,
                value: function (params, callback) {
                    console.log('[zk] [PayProtocol] aliPay')
                    var id = addCallback(callback);
                    W.invoke('aliPay', id, params);
                }
            },

            alipayVerify: {
                writable: false,
                value: function (params, callback) {
                    var id = addCallback(callback);
                    W.invoke('alipayVerify', id, params);
                }

            },

            bindAlipay: {
                writable: false,
                value: function (params, callback) {
                    var id = addCallback(callback);
                    W.invoke('bindAlipay', id, params);
                }
            },

            hasPayCallback: {
                writable: false,
                value: function () {
                    return W.invoke('hasPayCallback');
                }
            },

            setPayResult: {
                writable: false,
                value: function (state, data) {
                    W.invoke('setPayResult', state + '', data);
                }
            },

            isMobile4G: {
                get: function() {
                    return W.invoke('isMobile4G');
                }
            },

            onURLAction: {
                writable: false,
                value: function (pattern, callback) {
                    addURLAction(pattern, callback);
                }
            },

            offURLAction: {
                writable: false,
                value: function (pattern, callback) {
                    removeURLAction(pattern, callback);
                }
            },

            sdk_channel : {
                get : function() {
                    return W.invoke('sdk_channel');
                }
            }

        });

    } else {

        var W = new zk.WBPayProtocol();

        Object.defineProperties(wb, {
            gsid: {
                get: function () {
                    return W.gsid;
                }
            },
            uid: {
                get: function () {
                    return W.uid;
                }
            },
            from: {
                get: function () {
                    var v = W.params;
                    if (typeof v == 'object') {
                        return v['from'];
                    }
                }
            },
            vp: {
                get: function () {
                    var v = W.params;
                    if (typeof v == 'object') {
                        return v['v_p'];
                    }
                }
            },
            wm: {
                get: function () {
                    var v = W.params;
                    if (typeof v == 'object') {
                        return v['wm'];
                    }
                }
            },
            ua: {
                get: function () {
                    return W.ua;
                }
            },
            lang: {
                get: function () {
                    var v = W.params;
                    if (typeof v == 'object') {
                        return v['lang'];
                    }
                }
            },
            baseURL: {
                get: function () {
                    return W.baseURL;
                },
                set: function (v) {
                    W.baseURL = v;
                }
            },
            unreadCount: {
                writable: false,
                value: function (id) {
                    return W.unreadCount(id + '');
                }
            },
            read: {
                writable: false,
                value: function (id) {
                    return W.read(id + '');
                }
            },
            act: {
                writable: false,
                value: function (code, data) {
                    W.act(code + '', data);
                }
            },

            openURL: {
                writable: false,
                value: function (url) {
                    zk.openURL(url);
                }
            },

            isDeviceApplePayEnabled: {
                get: function () {
                    return W.isDeviceApplePayEnabled
                }
            },

            isDeviceAlipayEnabled: {
                get: function() {
                  return W.isDeviceAlipayEnabled
                }
            },

            applePay: {
                writable: false,
                value: function (tn, merchantType, mode, callback) {
                    var id = addCallback(callback);
                    W.applePay(id, tn + '', merchantType + '', mode + '');
                }
            },

            isDeviceWxPayEnabled: {
                get: function () {
                    return W.isDeviceWxPayEnabled
                }
            },

            wxPay: {
                writable: false,
                value: function (params, callback) {
                    var id = addCallback(callback);
                    W.wxPay(id, params);
                }
            },

            hasPayCallback: {
                writable: false,
                value: function () {
                    return W.hasPayCallback();
                }
            },

            setPayResult: {
                writable: false,
                value: function (state, data) {
                    W.setPayResult(state + '', data);
                }
            },

            aliPay: {
                writable: false,
                value: function (data, callback) {
                    var id = addCallback(callback);
                    W.aliPay(id, data + '');
                }
            },

            bindAlipay: {
                writable: false,
                value: function (data, callback) {
                    var id = addCallback(callback);
                    W.bindAlipay(id, data + '');
                }
            },

            alipayVerify: {
                writable: false,
                value: function (params, callback) {
                    var id = addCallback(callback);
                    W.alipayVerify(id, params);
                }
            },

            isMobile4G: {
                get: function() {
                    return false;
                }
            },

            onURLAction: {
                writable: false,
                value: function (pattern, callback) {
                    addURLAction(pattern, callback);
                }
            },

            offURLAction: {
                writable: false,
                value: function (pattern, callback) {
                    removeURLAction(pattern, callback);
                }
            },

            sdk_channel : {
                get : function() {
                    return W.sdk_channel;
                }
            }

        });

    }

};


