"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _chan=new zk.Isolate(zk.Isolate.Type_IO);var _textEncoder=new TextEncoder;function IO(){return _chan}exports.IO=IO;function createFile(URI){_chan.exec(function(URI){try{var fd=new zk.File(URI,"w");fd.close()}catch(e){zk.log("[io.createFile] "+e.stack)}},URI)}exports.createFile=createFile;function saveFile(URI,data){if(typeof data=="string"){data=_textEncoder.encode(data)}_chan.exec(function(URI,data){try{var fd=new zk.File(URI,"w");fd.write(data,data.byteLength,1);fd.close()}catch(e){zk.log("[io.saveFile] "+e.stack)}},URI,data)}exports.saveFile=saveFile;function appendFile(URI,data){if(typeof data=="string"){data=_textEncoder.encode(data)}_chan.exec(function(URI,data){try{var fd=new zk.File(URI,"a");fd.write(data,data.byteLength,1);fd.close()}catch(e){zk.log("[io.appendFile] "+e.stack)}zk.gc()},URI,data)}exports.appendFile=appendFile;function writeFile(URI,data){if(typeof data=="string"){data=_textEncoder.encode(data)}_chan.exec(function(URI,data){try{var fd=new zk.File(URI,"w");fd.write(data,data.byteLength,1);fd.close()}catch(e){zk.log("[io.appendFile] "+e.stack)}zk.gc()},URI,data)}exports.writeFile=writeFile;function copyFile(URI,toURI){_chan.exec(function(URI,toURI){try{var fd=new zk.File(URI,"r");try{try{var wd=new zk.File(toURI,"w");try{var data=new ArrayBuffer(204800);var n=void 0;while((n=fd.read(data,1,data.byteLength))>0){wd.write(data,1,n)}}finally{wd.close()}}catch(e){zk.log("[io.copyFile] "+e.stack);return}}finally{fd.close()}}catch(e){zk.log("[io.copyFile] "+e.stack);return}zk.gc()},URI,toURI)}exports.copyFile=copyFile;function rename(URI,toURI){_chan.exec(function(URI,toURI){zk.rename(URI,toURI)},URI,toURI)}exports.rename=rename;function remove(URI){_chan.exec(function(URI){zk.remove(URI)},URI)}exports.remove=remove;function mkdir(URI){_chan.exec(function(URI){function mkdir(dir){var i=dir.lastIndexOf("/");if(i>=0){mkdir(dir.substr(0,i))}try{new zk.Stat(dir)}catch(e){zk.mkdir(dir)}}mkdir(URI)},URI)}exports.mkdir=mkdir;function unzip(src,dst){_chan.exec(function(src,dst){try{zk.zlib.unzip(src,dst)}catch(e){zk.log("[io.unzip] "+e.stack)}},src,dst)}exports.unzip=unzip;var autoId=0;var cbSet={};function done(cb){var id=++autoId;cbSet[id]=cb;_chan.exec(function(id){zk.exec(function(id){require("io.js").__done(id)},id)},id)}exports.done=done;function __done(id){var args=[];for(var _i=1;_i<arguments.length;_i++){args[_i-1]=arguments[_i]}var f=cbSet[id];delete cbSet[id];if(typeof f=="function"){f.apply(undefined,args)}}exports.__done=__done;function wait(){_chan.call(function(){})}exports.wait=wait;function readdir(URI,cb){var id=++autoId;cbSet[id]=cb;_chan.exec(function(id,URI){var vs=[];try{var dir=new zk.Dir(URI);var s=void 0;while(s=dir.next()){if(s=="."||s==".."){continue}vs.push(s)}dir.close()}catch(e){zk.log("[io.readdirSync]"+e.stack)}zk.exec(function(id,vs){require("io.js").__done(id,vs)},id,vs)},id,URI)}exports.readdir=readdir;function readdirSync(URI){return _chan.call(function(URI){var vs=[];try{var dir=new zk.Dir(URI);var s=void 0;while(s=dir.next()){if(s=="."||s==".."){continue}vs.push(s)}dir.close()}catch(e){zk.log("[io.readdirSync]"+e.stack)}return vs},URI)}exports.readdirSync=readdirSync;function getFileInfoSync(URI){return _chan.call(function(URI){try{var s=new zk.Stat(URI);return{size:s.size(),isdir:s.isdir(),mtime:s.mtime()}}catch(e){zk.log("[io.getFileInfo]"+e.stack)}},URI)}exports.getFileInfoSync=getFileInfoSync;function getFileInfo(URI,cb){var id=++autoId;cbSet[id]=cb;_chan.exec(function(id,URI){try{var s=new zk.Stat(URI);zk.exec(function(id,res){require("io.js").__done(id,res)},id,{size:s.size(),isdir:s.isdir(),mtime:s.mtime()})}catch(e){zk.log("[io.getFileInfo]"+e.stack);zk.exec(function(id){require("io.js").__done(id)},id)}},id,URI)}exports.getFileInfo=getFileInfo;function readFileSync(URI){return _chan.call(function(URI){try{var s=new zk.Stat(URI);var n=s.size();var fd=new zk.File(URI,"r");var data=new ArrayBuffer(n);try{if(fd.read(data,1,n)==n){return data}}finally{fd.close()}}catch(e){zk.log("[io.getFileInfo]"+e.stack)}},URI)}exports.readFileSync=readFileSync;function readFile(URI,cb){var id=++autoId;cbSet[id]=cb;_chan.exec(function(id,URI){try{var s=new zk.Stat(URI);var n=s.size();var fd=new zk.File(URI,"r");var data=new ArrayBuffer(n);try{if(fd.read(data,1,n)==n){zk.exec(function(id,data){require("io.js").__done(id,data)},id,data)}}finally{fd.close()}}catch(e){zk.log("[io.getFileInfo]"+e.stack);zk.exec(function(id){require("io.js").__done(id)},id)}},id,URI)}exports.readFile=readFile;